#include "evalParamsCombinedModel.h"
#include "someUtil.h"
#include "errorMsg.h"
#include <cmath>
using namespace std;

//MDOUBLE evalParamsCombinedModel::operator()(MDOUBLE x)
//{
//	_pCombinedModel->setParam(_param, x);
//	MDOUBLE LL = _pCombinedModel->compLogLikelihood(_tr, _charContainer, _seqContainer, _mappingNum, _heuristicGroups);
//	return -LL;
//}


MDOUBLE evalParamsSeqModel::operator()(MDOUBLE x)
{	
	_pCombinedModel->setParam(_param, x);
	LOG(11, <<"inside evalParamsSeqModel. x = "<<x<<endl;); 
    MDOUBLE LL = _pCombinedModel->compLogLikelihood(_inTrees, _seqContainer, _weights, _charTrees, _charContainer, _llType);
	return -LL;
}


//MDOUBLE evalParamsRelativeRate::operator()(MDOUBLE x)
//{	
//	_pCombinedModel->setParam(RELATIVE_RATE, x);
//    MDOUBLE LL = _pCombinedModel->compLogLikelihood(_tr, _mappings, _seqContainer, _heuristicGroups);
//	return -LL;
//}


MDOUBLE evalParamsCombinedModelManyTrees::operator()(MDOUBLE x)
{
	_pCombinedModel->setParam(_param, x);
	MDOUBLE LL = _pCombinedModel->compLogLikelihood(_trees, _charContainer, _seqContainer, _mappingNum, _heuristicGroups, _trees, _llType);
	return -LL;
}


MDOUBLE evalParamsRelativeRateManyTrees::operator()(MDOUBLE x)
{	
	_pCombinedModel->setParam(RELATIVE_RATE, x);
    MDOUBLE LL = _pCombinedModel->compLogLikelihood(_trees, _mappings, _seqContainer, _heuristicGroups, _trees, _charContainer, _llType);
	return -LL;
}

MDOUBLE evalParamsTreeLengthManyTrees::operator()(MDOUBLE x)
{	
	_pCombinedModel->setParam(TREE_LENGTH, x);
    MDOUBLE LL = _pCombinedModel->compLogLikelihood(_trees, _mappings, _seqContainer, _heuristicGroups, _trees, _charContainer, _llType);
	return -LL;
}

